import java.util.*;

public class Judge {
    private List players;
    private List hands;

    // RXgN^
    //   ̓vC[̐
    public Judge(int playerSize){
        players = new ArrayList();
        hands = new ArrayList();

        for(int i = 0 ; i < playerSize ; i++){
            players.add(new Player("Player" + i));
        }
    }

    // Q[̃C[`
    public void playGame(){
        // vC[Ɏ₢킹
        for(int i = 0 ; i < players.size() ; i++){
            Player player = (Player)players.get(i);
            int hand = player.getHand();
            hands.add(new Integer(hand));
        }

        // 
        List winners = judge(hands);

        // ̏o
        for(int i = 0 ; i < players.size() ; i++){
            Player player = (Player)players.get(i);
            int hand = ((Integer)hands.get(i)).intValue();
            System.out.println(player.getName() + "'s hand is "
                               + Player.valueOf(hand));
        }

        if(winners.isEmpty()){
            System.out.println("Draw!");
        }else{
            for(int i = 0 ; i < winners.size() ; i++){
                Player player = (Player)winners.get(i);
                System.out.println("Winner is " + player.getName());
            }
        }
    }

    // 胋[`
    private List judge(List hands){
        List gooPlayers = new ArrayList();
        List chokiPlayers = new ArrayList();
        List paPlayers = new ArrayList();

        classify(gooPlayers, chokiPlayers, paPlayers, hands);

        if(gooPlayers.isEmpty()){
            if(chokiPlayers.isEmpty()){
                // Sp[
                return new ArrayList(); // 
            }else{
                if(paPlayers.isEmpty()){
                    // S`L
                    return new ArrayList(); // 
                }else{
                    // `Lƃp[Ń`L̏
                    return chokiPlayers;
                }
            }
        }else if(chokiPlayers.isEmpty()){
            if(paPlayers.isEmpty()){
                // SO[
                return new ArrayList();
            }else{
                // p[ƃO[Ńp[̏
                return paPlayers;
            }
        }else if(paPlayers.isEmpty()){
            // O[ƃ`LŃO[̏
            return gooPlayers;
        } else {
            // O[A`LAp[ł
            return new ArrayList();
        }
    }

    private void classify(List gooPlayers, List chokiPlayers, List paPlayers, List hands){
        for(int i = 0 ; i < hands.size() ; i++){
            int hand = ((Integer)hands.get(i)).intValue();
            switch(hand){
              case Player.GOO:
                gooPlayers.add(players.get(i));
                break;
              case Player.CHOKI:
                chokiPlayers.add(players.get(i));
                break;
              case Player.PA:
                paPlayers.add(players.get(i));
                break;
              default:
                break;
            }
        }
    }
}
